unit PT_Init;
interface

function Init:word;

implementation
uses crt;

procedure ShareWare;
begin
  window(2,1,79,24);
  TextBackground(7);
  clrscr;
  TextBackground(0);
  window(10,3,75,22);
  clrscr;

  TextBackground(1);
  TextColor(white+blink);
  Window(9,2,73,21);
  clrscr;
  write('               ');
  TextBackground(Magenta);
  writeln('SaveImage V1.1+ by Stanimir Simeonoff');
  TextBackground(9);
  writeln;
  TextColor(Yellow);
  writeln(' This program is SHAREWARE. You may use it freely for a 20 day');
  writeln(' evaluation period. At the end of this period, you must either ');
  writeln(' register SaveImage or stop using it.');
  writeln;
  writeln(' To register SaveImage, please complete the registration form');
  writeln(' provided and mail it along with US$15 to the address below.');
  writeln(' If this price seems too much to you... Don''t bother yourself.');
  writeln(' Just send me a postcard of your town. But if you''re rich enough');
  writeln(' please don''t play games with me. I''m just a poor Bulgarian...');
  writeln(' Add US$100 for the source code if you have an interest. This');
  writeln(' program costs me so much time and ... ''cause I didn''t use any');
  writeln(' libraries. So you''ll get the entire code. Probably you''ll be');
  writeln(' able to learn something new.');
  TextColor(Red);
  writeln('            Bulgaria');
  writeln('            town of Lyascotetz');
  writeln('            Stoicho Kurkev str., #17g');
  writeln('            Stanimir Simeonoff');
end;

procedure Wait(sec:byte);
var
  i:word;
  SavIMR:byte;
begin
  asm
    in al,21h
    mov SavIMR,al
    or al,3
    xor cx,cx
    @here: loop @here
    out 21h,al    {disable timer and KBD}
  end;
  TextColor(15+blink);
  GotoXY(20,20);
  write('Wait ',sec,' seconds and press a key');
  for i:=1 to sec do
  begin
    sound(300);delay(100);nosound;delay(990);
  end;
  asm
    mov al,SavIMR
    out 21h,al
  end;
  GotoXY(20,20);write('                   Press a key');
  ReadKey;
  GotoXY(37,20);write('             ');

end;

procedure Help;
begin
  Window(1,1,80,25);
  TextColor(7);
  TextBackground(Black);

  ClrScr;
  writeln('      SaveImage V1.1+ by Stanimir Simeonoff');
  writeln ('Usage:');
  writeln ('      /u: Unload');
  writeln ('      /s: No sound while capture is on');
  writeln ('      /i#: Alternate interrupts, where # is an number(1-9)');
  writeln ('      /?: This help screen');
  halt (10);
end;
procedure  FixBug;assembler;
asm
  mov ax,4f02h {fixes a bug found in some VESA drivers}
  mov bx,102h  {as calls the driver. This sets the}
  int 10h      {environment properly.}
end;
function DetectEMS:byte;assembler;
asm
  mov ax,3567h  {Get INT vector}
  int 21h
  mov cx,8      {length of signature}
  push ds       {store DS}
  push cs       {and set}
  pop ds        {DS to CS}
  mov si,offset @EMM_sign {at DS:SI is a string that indicates LIM/EMS}
  mov di,10               {at ES:DI must be the same one}
  repe CMPSB              {if LIM/EMS is installed}
  pop ds                  {restore DS}
  mov al,cl               {set result (0-if successful)}
  jmp @out                {go out}
  @EMM_sign:db 'EMMXXXX0'
  @out:
end;

function Init:word;

const
  Alternate_IRQ:array[0..9] of byte=
            ($50,$58,$68,$88,$98,$a0,$b0,$c0,$d0,$e0);
var
  i:byte;
  IsVGA:byte absolute i;
  Is286:byte absolute i;
  prm:string;
  prm_length:byte;
  result:word;
begin

  FixBug; {Fix a bug found in some VESA drivers}
  asm
    mov ax,3   {set mode 80x25}
    int 10h
  end;

  result:=$5000;   {clear result}
  if DetectEMS=0 then result:=result or 4;
  for i:=1 to 9 do
  begin
    prm:=ParamStr(i);
    prm_length:=byte(prm[0]);
    prm[0]:=#2;
    if (prm='/?') or (prm='/h') then
    begin
      ShareWare;
      Wait(1);
      Help;
    end;
    if prm='/s' then result:=result or 2;
    if prm='/u' then result:=result or 1;
    if prm='/i' then
      asm
        xor si,si
        xor ah,ah
        mov al,byte ptr prm[3]
        cmp al,'1'
        jb @SetIRQ
        cmp al,'9'
        ja @SetIRQ
        sub al,30h
        mov si,ax
        @SetIRQ:
        mov al,byte ptr Alternate_IRQ[si]
        mov byte ptr result+1,al
      end;
  end;
  if (result and 1)=0 then
  begin
    ShareWare;
    Wait(2);
    TextColor(7);
    TextBackground(Black);
    window(1,23,80,25);
    clrscr;
    Window(1,1,80,25);
    GotoXY(1,22);
  end;
  Init:=result;
end;

var
  IsVGA:byte;
  Is286:byte absolute IsVGA;
begin
  {SaveImage requires at least 286 and VGA}
  asm
    mov ax,1a00h {this function presents only in VGA+}
    int 10h
    mov IsVGA,al {AL should be 1ah if VGA is on board}
  end;
  if IsVGA<>$1a then
  begin
    writeln ('Sorry! You need at least VGA to launch SaveImage');
    halt (255);
  end;
  asm
    pushf
    pop bx        {BX:=Flags}
    and bx,0fffh
    push bx
    popf
    pushf
    pop bx
    and bx,0f000h
    cmp bx,0f000h
    mov al,0
    jz  @store_res
    inc al
   @store_res:
    mov Is286,al
  end;
  if Is286=0 then
  begin
    writeln ('Sorry! You need 286 or better to launch SaveImage');
    halt (254);
  end;
end.
